package com.ruoyi.service.impl;

import com.ruoyi.domain.vo.QuantityStatisticsVO;
import com.ruoyi.domain.vo.StandardCategoryStatisticsVO;
import com.ruoyi.mapper.StatisticsHomeMapper;
import com.ruoyi.service.StatisticsHomeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class StatisticsHomeServiceImpl implements StatisticsHomeService {
    @Autowired
    private StatisticsHomeMapper statisticsHomeMapper;

    @Override
    public QuantityStatisticsVO selectQuantityStatistics(QuantityStatisticsVO quantityStatisticsHome){

        QuantityStatisticsVO quantityStatisticsVO =  statisticsHomeMapper.selectQuantityStatistics(quantityStatisticsHome);
        quantityStatisticsVO.setExecuteTaskProportion(percentageCalculation(quantityStatisticsVO.getExecuteTasksNumber(),quantityStatisticsVO.getCompletedTaskNumber()));
        quantityStatisticsVO.setCompletedTaskProportion(percentageCalculation(quantityStatisticsVO.getCompletedTaskNumber(),quantityStatisticsVO.getExecuteTasksNumber()));
        return quantityStatisticsVO;
    }

    @Override
    public List<StandardCategoryStatisticsVO> selectStandardCategoryStatistics(){
        return statisticsHomeMapper.selectStandardCategoryStatistics();
    }

    // 计算百分比
    public int percentageCalculation(Integer a, Integer b){
        int total = a+b;
        if(total == 0){
            return 0;
        }else {
            float c = (float)a/total;
            return Math.round(c*100);
        }
    }
}
